/*-
 * ~~~~~~licensing~~~~~~
 * system-commons
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.common.aggregation;

import java.util.Map;
import java.util.stream.Collectors;

import org.apache.camel.AggregationStrategy;
import org.apache.camel.Exchange;

public class HeaderMergeAggregatorImpl implements AggregationStrategy {

    @Override
    public Exchange aggregate(Exchange oldExchange, Exchange newExchange) {
    	if (oldExchange != null && newExchange != null) {
	        Map<String, Object> oldHeaders = oldExchange.getIn().getHeaders();
	        Map<String, Object> newHeaders = newExchange.getIn().getHeaders();
	        
	        oldHeaders = oldHeaders.entrySet().stream()
	        				.filter(e -> !newHeaders.containsKey(e.getKey()))
	        				.collect(Collectors.toMap(e->e.getKey(), e->e.getValue()));
	        newExchange.getIn().getHeaders().putAll(oldHeaders);
    	}
        return newExchange;
    }

}
